public class XsltUtil
{
	private static final long D20 = 20L * 86400L * 1000L;
	private static final long D40 = 40L * 86400L * 1000L;
	private static final long D80 = 80L * 86400L * 1000L;

	/** See how recent the given date is. If it parses and is more than the given number of days ago return a code:
	  *    0 for less than 20 days ago
	  *    1 for more than that but less than 40 days ago
	  *    2 for more than that but less than 80 days ago.
	  * Otherwise return an empty string.
	  * This enables the XSLT to colour code the new or mod attributes of the page element, the colour fading with time. */
	public static String recent (String dd_MMM_yy)
	{
		try
		{
			java.text.SimpleDateFormat format = new java.text.SimpleDateFormat ("d MMM y");
			long then = format.parse (dd_MMM_yy).getTime ();
			long now = new java.util.Date ().getTime ();
			long duration = now - then;

			if (duration < D20) return "0";
			if (duration < D40) return "1";
			if (duration < D80) return "2";
		}
		catch (java.text.ParseException ex)	{}

		return "";
	} // recent
	
	/** Rearrange the input string, which may have 1 or 2 digits for the day part, to become more
	  * astronomical: 20yy_MMM_dd */
	public static String reorder (String dd_MMM_yy)
	{
		StringBuffer sb = new StringBuffer ("20");
		int len = dd_MMM_yy.length ();
		
		if (len == 9) // 2 digits for day
		{
			sb.append (dd_MMM_yy.substring (7)); // yy
			sb.append (" ");
			sb.append (dd_MMM_yy.substring (3, 6)); // MMM
			sb.append (" ");
			sb.append (dd_MMM_yy.substring (0, 2)); // dd
		}
		else if (len == 8) // 1 digit for day
		{
			sb.append (dd_MMM_yy.substring (6)); // yy
			sb.append (" ");
			sb.append (dd_MMM_yy.substring (2, 5)); // MMM
			sb.append (" ");
			sb.append (dd_MMM_yy.substring (0, 1)); // d
		}
		
		return sb.toString ();
	} // reorder

} // XsltUtil