<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE xsl:stylesheet[
	<!ENTITY copy "<xsl:value-of select='$COPY' disable-output-escaping='yes'/>">
	<!ENTITY nbsp "<xsl:value-of select='$NBSP' disable-output-escaping='yes'/>">
]>
<xsl:stylesheet 
	version="1.1"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="http://xml.apache.org/xalan"
	xmlns:redirect="http://xml.apache.org/xalan/redirect"
	xmlns:util="XsltUtil"
  	extension-element-prefixes="redirect"
	exclude-result-prefixes="xalan util">
	
	<!-- This stylesheet generates documentation for GRIP as a linked set
	     of XHTML pages, complete with contents and index pages.
	     See pages-explain.xml for how to write the content as XML. -->
	     
	<xsl:param name="targetdir"/>
	<!-- Recognised values of this command line parameter are 'site' (for 
	     the main web site) and 'help' (for smaller set of help pages).
	     It mainly affects how the <ax> element is processed. -->     
	
	<xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes" 
		doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
		doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" />
	<xsl:strip-space elements="*"/>
        
	<xsl:variable name="COPY"><![CDATA[&copy;]]></xsl:variable>
	<xsl:variable name="NBSP"><![CDATA[&nbsp;]]></xsl:variable>

	<xsl:variable name="INDEX">
		<xsl:for-each select="pages/page|document(pages/include)/pages/page">
			<xsl:apply-templates select=".//x|.//y" mode="index">
				<xsl:with-param name="filename" select="concat(@id,'.html')"/>
			</xsl:apply-templates>
		</xsl:for-each>
<a class="to" name="A">A</a>
<a class="to" name="B">B</a>
<a class="to" name="C">C</a>
<a class="to" name="D">D</a>
<a class="to" name="E">E</a>
<a class="to" name="F">F</a>
<a class="to" name="G">G</a>
<a class="to" name="H">H</a>
<a class="to" name="I">I</a>
<a class="to" name="J">J</a>
<a class="to" name="K">K</a>
<a class="to" name="L">L</a>
<a class="to" name="M">M</a>
<a class="to" name="N">N</a>
<a class="to" name="O">O</a>
<a class="to" name="P">P</a>
<a class="to" name="Q">Q</a>
<a class="to" name="R">R</a>
<a class="to" name="S">S</a>
<a class="to" name="T">T</a>
<a class="to" name="U">U</a>
<a class="to" name="V">V</a>
<a class="to" name="W">W</a>
<a class="to" name="X">X</a>
<a class="to" name="Y">Y</a>
<a class="to" name="Z">Z</a>
	</xsl:variable>

	<!-- For generating next page link at bottom of each page: -->	
	<xsl:variable name="PAGELIST">
		<xsl:for-each select="pages/page|document(pages/include)/pages/page">
			<xsl:if test="not(@notincontents)">
				<xsl:element name="x"><xsl:value-of select="@id"/></xsl:element>
			</xsl:if>
		</xsl:for-each>
	</xsl:variable>

	<xsl:template match="pages">
		<xsl:if test="xalan:nodeset($INDEX)/*">
			<redirect:write file="{$targetdir}/idx.html">
<html>
	<head>
				<xsl:choose>
					<xsl:when test="/pages/page[@id='idx']/title">
						<title>grelf.net - <xsl:value-of select="/pages/page[@id='idx']/title"/></title>
					</xsl:when>
					<xsl:otherwise><title>grelf.net - Index</title></xsl:otherwise>
				</xsl:choose>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
				<xsl:apply-templates select="/pages/css" mode="head"/>
				<xsl:apply-templates select="/pages/page[@id='idx']/css" mode="head"/>
				<xsl:apply-templates select="/pages/js" mode="head"/>
				<xsl:apply-templates select="/pages/page[@id='idx']/js" mode="head"/>
	</head>
	<body onload="setLoaded()">
<!--
		<noscript>Either you have disabled scripting in your browser or the browser is blocking active content. You need to correct this to be able to see these pages completely. A small amount of JavaScript is used to enable you to email me.</noscript>
-->
				<xsl:call-template name="side">
					<xsl:with-param name="prefix" select=""/>
					<xsl:with-param name="pageID" select=""/>
				</xsl:call-template>
				<xsl:call-template name="header">
					<xsl:with-param name="prefix" select=""/>
				</xsl:call-template>
		<div id="mainContent">
				<xsl:choose>
					<xsl:when test="/pages/page[@id='idx']/h1">
						<xsl:copy-of select="/pages/page[@id='idx']/h1"/>
					</xsl:when>
					<xsl:otherwise><h1>Index<xsl:if test="$targetdir='help'"> of help pages</xsl:if></h1></xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="fromAtoZ"/>
			<div class="clear">&nbsp;</div>
				<xsl:for-each select="xalan:nodeset($INDEX)/*">
					<xsl:sort/>
					<xsl:copy-of select="."/><br/>
				</xsl:for-each>
			<div class="clear">&nbsp;</div>
				<xsl:call-template name="fromAtoZ"/>
				<xsl:call-template name="footer">
					<xsl:with-param name="prefix" select=""/>
				</xsl:call-template>
		</div>
	</body>
</html>
			</redirect:write>
		</xsl:if>

		<redirect:write file="{$targetdir}/contents.html">
<html>
	<head>
			<xsl:choose>
				<xsl:when test="/pages/page[@id='contents']/title">
					<title>grelf.net - <xsl:value-of select="/pages/page[@id='contents']/title"/></title>
				</xsl:when>
				<xsl:otherwise><title>grelf.net - Contents</title></xsl:otherwise>
			</xsl:choose>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
			<xsl:apply-templates select="/pages/css" mode="head"/>
			<xsl:apply-templates select="/pages/page[@id='contents']/css" mode="head"/>
		<link rel="stylesheet" type="text/css" href="css/contents.css"/>
			<xsl:apply-templates select="/pages/js" mode="head"/>
			<xsl:apply-templates select="/pages/page[@id='contents']/js" mode="head"/>
	</head>
	<body onload="setLoaded()">
<!--
		<noscript>Either you have disabled scripting in your browser or the browser is blocking active content. You need to correct this to be able to see these pages completely. A small amount of JavaScript is used to enable you to email me.</noscript>
-->
			<xsl:call-template name="side">
				<xsl:with-param name="prefix" select=""/>
				<xsl:with-param name="pageID" select=""/>
			</xsl:call-template>
			<xsl:call-template name="header">
				<xsl:with-param name="prefix" select=""/>
			</xsl:call-template>
		<div id="contents">
			<xsl:choose>
				<xsl:when test="/pages/page[@id='contents']/h1">
					<xsl:copy-of select="/pages/page[@id='contents']/h1"/>
				</xsl:when>
				<xsl:otherwise><h1>Contents<xsl:if test="$targetdir='help'"> of help pages</xsl:if></h1></xsl:otherwise>
			</xsl:choose>
			<xsl:for-each select="contents|document(include)/pages/contents|page|document(include)/pages/page">
				<xsl:if test="not(@notincontents)">
					<xsl:choose>
						<xsl:when test="h1">
				<p><a href="{concat(@id,'.html')}"><xsl:value-of select="h1"/></a></p>
						</xsl:when>
						<xsl:when test="part">
				<h2><xsl:value-of select="part"/></h2>
						</xsl:when>
						<xsl:when test="title">
				<p><a href="{concat(@id,'.html')}"><xsl:value-of select="title"/></a></p>
						</xsl:when>
						<xsl:otherwise>
				<p><a href="{concat(@id,'.html')}">Untitled page</a></p><br/>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:choose>
						<xsl:when test="@mod">
							<xsl:element name="span">
								<xsl:attribute name="class">
									<xsl:text>revised</xsl:text><xsl:value-of select="util:recent(@mod)"/>
								</xsl:attribute>
								<xsl:text>revised</xsl:text>
							</xsl:element>&nbsp;<span><xsl:value-of select="util:reorder(@mod)"/></span>
						</xsl:when>
						<xsl:when test="@new">
							<xsl:element name="span">
								<xsl:attribute name="class">
									<xsl:text>new</xsl:text><xsl:value-of select="util:recent(@new)"/>
								</xsl:attribute>
								<xsl:text>new</xsl:text>
							</xsl:element>&nbsp;<span><xsl:value-of select="util:reorder(@new)"/></span>
						</xsl:when>
					</xsl:choose>
					<br/>
				</xsl:if>
			</xsl:for-each>
			</div>
		<div>&nbsp;</div>
			<xsl:call-template name="footer">
				<xsl:with-param name="prefix" select=""/>
			</xsl:call-template>
	</body>
</html>
		</redirect:write>

		<!-- Generate all the other pages (not index or contents): -->
		<xsl:apply-templates select="page">
			<xsl:with-param name="source">pages.xml</xsl:with-param>
		</xsl:apply-templates>
		<xsl:apply-templates select="include">
			<xsl:with-param name="source" select="include"/>
		</xsl:apply-templates>
	</xsl:template><!-- match="pages" -->
	
	<xsl:template match="include">	
		<xsl:apply-templates select="document(.)/pages/page">
			<xsl:with-param name="source" select="."/>
		</xsl:apply-templates>
	</xsl:template>
	
	<xsl:template match="css" mode="head">
		<link rel="stylesheet" type="text/css" href="{.}"/>
	</xsl:template>

	<xsl:template match="js" mode="head">
		<script src="{.}" type="text/javascript">/**/</script>
	</xsl:template>
	
	<xsl:template match="meta" mode="head">
		<xsl:copy-of select="."/>
	</xsl:template>

	<xsl:template match="page">
		<xsl:param name="source"/>
		<xsl:if test="@id!='idx' and @id!='contents'">
			<xsl:variable name="ID" select="@id"/>

			<redirect:write file="{$targetdir}/{concat(@id,'.html')}">
<html>
	<head>
			<xsl:comment>Source file: <xsl:value-of select="$source"/></xsl:comment>
			<xsl:comment>Generated by XSLT v<xsl:value-of select="system-property('xsl:version')"/> from <xsl:value-of select="system-property('xsl:vendor')"/></xsl:comment>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
			<xsl:choose>
				<xsl:when test="title"><title>grelf.net - <xsl:value-of select="title"/></title></xsl:when>
				<xsl:otherwise><title>grelf.net</title></xsl:otherwise>
			</xsl:choose>
			<xsl:apply-templates select="/pages/css" mode="head"/>
			<xsl:apply-templates select="css" mode="head"/>
			<xsl:apply-templates select="/pages/js" mode="head"/>
			<xsl:apply-templates select="js" mode="head"/>
			<xsl:apply-templates select="meta" mode="head"/>
	</head>
	<body onload="setLoaded()">
<!--
		<noscript>Either you have disabled scripting in your browser or the browser is blocking active content. You need to correct this to be able to see these pages completely. A small amount of JavaScript is used to enable you to email me.</noscript>
-->
			<xsl:call-template name="side">
				<xsl:with-param name="prefix" select=""/>
				<xsl:with-param name="pageID" select="$ID"/>
			</xsl:call-template>
			<xsl:call-template name="header">
				<xsl:with-param name="prefix" select=""/>
			</xsl:call-template>
		<div id="mainContent">
			<xsl:choose>
				<xsl:when test="title and not(h1)">
			<h1><xsl:value-of select="title"/></h1>
				</xsl:when>
				<xsl:otherwise>
			<h1><xsl:value-of select="h1"/></h1>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="1 &lt; count(h2) + count(h3)">
			<div class="sectionLinks">
				<p> Sections in this page </p>
				<ul>
			<xsl:for-each select=".//h2|.//h3">
				<xsl:choose>
					<xsl:when test="name(.)='h2'">
					<li><strong><a href="#{generate-id(.)}"><xsl:value-of select="."/></a></strong></li>
					</xsl:when>
					<xsl:otherwise>
					<li> - <a href="#{generate-id(.)}"><xsl:value-of select="."/></a></li>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
				</ul>
			</div>
			</xsl:if>
			<xsl:apply-templates/>
			<xsl:if test="not(@notincontents)">
			<div class="nextPage">
				<xsl:variable name="NEXTID">
					<xsl:for-each select="xalan:nodeset($PAGELIST)/*">
						<xsl:if test="$ID=.">
							<xsl:choose>
								<xsl:when test="position()=last()">
									<xsl:value-of select="xalan:nodeset($PAGELIST)/*[1]"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="following-sibling::*"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:if>
					</xsl:for-each>
				</xsl:variable>
				<a href="{concat($NEXTID,'.html')}">Next page</a>
			</div>
			</xsl:if>
		</div>
			<xsl:call-template name="footer">
				<xsl:with-param name="prefix" select=""/>
				<xsl:with-param name="mod" select="util:reorder(@mod)"/>
				<xsl:with-param name="new" select="util:reorder(@new)"/>
			</xsl:call-template>
	</body>
</html>
			</redirect:write>
		</xsl:if>
	</xsl:template><!-- match="page"-->

	<xsl:template match="i">
		<img src="{.}" width="{@w}" height="{@h}" alt="{@a}"/>
	</xsl:template>

	<xsl:template name="side">
		<xsl:param name="prefix"/>
		<xsl:param name="pageID"/>
		<div id="side">
			<p class="sideLink"><a href="#top">Page top</a></p>
		<xsl:if test="/pages/page[@id='index']">
			<p class="sideLink"><a href="{concat($prefix,'index.html')}">Home page</a></p>
		</xsl:if>
			<p class="sideLink"><a href="{concat($prefix,'contents.html')}">Contents</a></p>
		<xsl:if test="xalan:nodeset($INDEX)/*">
			<p class="sideLink"><a href="{concat($prefix,'idx.html')}">Index</a></p>
		</xsl:if>
		<xsl:if test="$targetdir='site'">
			<p class="sideLink" style="font-size:smaller"><a href="{concat($prefix,'docs/index.html')}">API (for<br/>programmers)</a></p>
		</xsl:if>
			<p class="sideLink"><a href="#bottom">Page bottom</a></p>
		<xsl:choose>
			<xsl:when test="string-length($pageID)&gt;0">
				<xsl:variable name="NEXTID">
					<xsl:for-each select="xalan:nodeset($PAGELIST)/*">
						<xsl:if test="$pageID=.">
							<xsl:choose>
								<xsl:when test="position()=last()">
									<xsl:value-of select="xalan:nodeset($PAGELIST)/*[1]"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="following-sibling::*"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:if>
					</xsl:for-each>
				</xsl:variable>
				<xsl:if test="string-length($NEXTID)&gt;0">
						<p class="sideLink"><a href="{concat($NEXTID,'.html')}">Next page</a></p>
				</xsl:if>
			</xsl:when>
		</xsl:choose>
			<img src="{concat($prefix,'im/logo_vert_100x454.jpg')}" width="100" height="454" alt="Site logo, www.grelf.net"/>
		</div>
	</xsl:template>
	
	<xsl:template name="header">
		<xsl:param name="prefix"/>
		<div class="clear"><a class="anchorOnly" name="top">&nbsp;</a></div>
		<div id="banner">
			<div class="grip-logo">
				<a href="grip_intro.html"><img width="200" height="50" alt="GRIP logo" src="{concat($prefix,'im/grip.png')}" title="GR&#39;s Image Processor - get it here - free"/></a>
			</div>
			<div id="bannerText">
				<div id="jd" title="Julian date, only as accurate as your system clock">&nbsp;</div>
				<div id="moon">&nbsp;</div>
				<div class="emailAddress">gr&lt;at&gt;grelf&lt;dot&gt;net</div>
			</div>
		</div>
	</xsl:template>

	<xsl:template name="footer">
		<xsl:param name="prefix"/>
		<xsl:param name="new"/>
		<xsl:param name="mod"/>
		<div id="footer">
			<div class="clear"><a class="anchorOnly" name="bottom">&nbsp;</a></div>
			<div class="line">&nbsp;</div>
			<a href="grip_intro.html"><img class="grip-logo" width="200" height="50" alt="GRIP logo" src="{concat($prefix,'im/grip.png')}" title="GR&#39;s Image Processor - get it here - free"/></a>
			<div style="height:50px;">
				<p style="float:right; font-size:smaller">
				<xsl:if test="4&lt;string-length($new)">Page new <xsl:value-of select="$new"/>.</xsl:if>
				<xsl:if test="4&lt;string-length($mod)"> Page modified <xsl:value-of select="$mod"/>.</xsl:if>
				</p>
<!--
				<div class="globalLink"><a href="#top">Top</a></div>
		<xsl:if test="$targetdir='site'">
				<div class="globalLink"><a href="docs/index.html">API</a></div>
		</xsl:if>
		<xsl:if test="xalan:nodeset($INDEX)/*">
				<div class="globalLink"><a href="idx.html">Index</a></div>
		</xsl:if>
				<div class="globalLink"><a href="contents.html">Contents</a></div>
		<xsl:if test="/pages/page[@id='index']">
				<div class="globalLink"><a href="index.html">Home</a></div>
		</xsl:if>
-->
			</div>
		<xsl:call-template name="copyright"/>
		</div>
	</xsl:template>

	<xsl:template match="a">
		<xsl:element name="a">
			<xsl:if test="@name">
				<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@href">
				<xsl:attribute name="href"><xsl:value-of select="@href"/></xsl:attribute>
				<xsl:choose>
					<xsl:when test="starts-with(@href,'http://')">
						<xsl:attribute name="target">_blank</xsl:attribute>
						<xsl:attribute name="class"><xsl:text>extLink</xsl:text></xsl:attribute>
					</xsl:when>
					<xsl:when test="starts-with(@href,'https://')">
						<xsl:attribute name="target">_blank</xsl:attribute>
						<xsl:attribute name="class"><xsl:text>extLink</xsl:text></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="@target">
								<xsl:attribute name="target"><xsl:value-of select="@target"/></xsl:attribute>
								<xsl:attribute name="class"><xsl:text>extLink</xsl:text></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="class"><xsl:text>intLink</xsl:text></xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="*|text()">
					<xsl:apply-templates/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="class"><xsl:text>anchorOnly</xsl:text></xsl:attribute>
					<xsl:text>&nbsp;</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>

	<!-- ax is a special kind of link, assumed to have @href but not any other attributes.
	     If $targetdir has the value 'help' this link must go online to www.grelf.net.
	     Otherwise it will find the target in the local directory because it is one of the help pages. -->
	<xsl:template match="ax">
		<xsl:element name="a">
			<xsl:choose>
				<xsl:when test="$targetdir='help'">
					<xsl:attribute name="href">http://www.grelf.net/<xsl:value-of select="@href"/></xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="href"><xsl:value-of select="@href"/></xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="*|text()">
					<xsl:apply-templates/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="class"><xsl:text>anchorOnly</xsl:text></xsl:attribute>
					<xsl:text>&nbsp;</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
	</xsl:template>

	<xsl:template match="char">
		<xsl:value-of disable-output-escaping="yes" select="concat('&amp;',@code,';')"/>
	</xsl:template>

	<xsl:template match="h1"/> <!-- Already dealt with -->
	
	<xsl:template match="h2">
		<h2><a class="anchorOnly" name="{generate-id(.)}">&nbsp;</a><xsl:value-of select="."/></h2>
	</xsl:template>
	
	<xsl:template match="h3">
		<h3><a class="anchorOnly" name="{generate-id(.)}">&nbsp;</a><xsl:value-of select="."/></h3>
	</xsl:template>

	<xsl:template match="R"><br/>From Rookhope 54.8<char code="deg"/>N 2.1<char code="deg"/>W 330m asl. Rural, almost no light pollution <a href="http://en.wikipedia.org/wiki/Bortle_Dark-Sky_Scale" target="_blank">(3 Bortles)</a></xsl:template>
	
	<xsl:template match="W"><br/>From Whitley Bay 55.1<char code="deg"/>N 1.5<char code="deg"/>W 10m asl. Suburban, significant light pollution <a href="http://en.wikipedia.org/wiki/Bortle_Dark-Sky_Scale" target="_blank">(6.5 Bortles)</a></xsl:template>
	
	<xsl:template match="x">
		<xsl:choose>
			<xsl:when test="name(..)='z'">
				<xsl:value-of select="."/>
			</xsl:when>
			<xsl:otherwise>
		<a name="{generate-id(.)}"><xsl:value-of select="."/></a>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="y">
		<xsl:if test="name(..)!='z'">
		<a class="anchorOnly" name="{generate-id(.)}">&nbsp;</a>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="z">
		<a class="anchorOnly" name="{generate-id(.)}">&nbsp;</a>
	</xsl:template>

	<xsl:template match="x|y" mode="index">
		<xsl:param name="filename"/>
		<xsl:choose>
			<xsl:when test="name(..)='z'">
		<a href="{$filename}#{generate-id(..)}"><xsl:value-of select="."/></a>
			</xsl:when>
			<xsl:otherwise>
		<a href="{$filename}#{generate-id(.)}"><xsl:value-of select="."/></a>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- 
		For gallery pages we can have any number of <photo> elements:
		<photo id="">
			<thumb width="" height="" alt=""/>
			<img width="" height="" alt=""/>
			<tech>Canon EOS 5D 100-400mm @ 400mm<br/>1/1000s f/11 ISO400 2007:04:27 17:56:17</tech>
			<p>Optional paragraphs of description - and other HTML as needed</p>
		</photo>

		The thumbnail file is assumed to be ph/th/{@id}.jpg and will be put in a <div class="thumb">.
		The main image is assumed to be ph/{@id}.jpg and a new page ph/{@id}.html is created for it but not in contents.
		The optional <tech> content goes in a <p class="photo"> under the main <img> in its new page.
		The optional <p> content and any other HTML also goes in that page, as plain <p>.
	-->

	<xsl:template match="photo">
		<div class="thumb">
			<a href="{concat('ph/',@id,'.html')}" target="_blank">
				<img src="{concat('ph/th/',@id,'.jpg')}" width="{thumb/@width}" height="{thumb/@height}" alt="{thumb/@alt}" title="{thumb/@alt}"/>
			</a>
		</div>

		<redirect:write file="ph/{@id}.html">
<html>
	<head>
		<title><xsl:text>grelf.net - </xsl:text><xsl:value-of select="@id"/>.jpg</title>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
		<link rel="stylesheet" type="text/css" href="../css/global.css"/>
		<script src="../js/global.js" type="text/javascript">/**/</script>
	</head>
	<body onload="setLoaded()">
			<xsl:call-template name="side">
				<xsl:with-param name="prefix">../</xsl:with-param>
				<xsl:with-param name="pageID" select=""/>
			</xsl:call-template>
			<xsl:call-template name="header">
				<xsl:with-param name="prefix">../</xsl:with-param>
			</xsl:call-template>
		<div id="mainContent">
			<img src="{concat(@id,'.jpg')}" width="{img/@width}" height="{img/@height}" alt="{img/@alt}" title="{img/@alt}"/>
			<xsl:if test="tech">
			<p class="photo"><xsl:value-of select="tech"/></p>
			</xsl:if>
			<p class="photo">Copyright &copy; grelf.net, UK, 2006-2017</p>
			<xsl:apply-templates select="p"/>
			<xsl:call-template name="footer">
				<xsl:with-param name="prefix">../</xsl:with-param>
			</xsl:call-template>
		</div>
	</body>
</html>
		</redirect:write>
	</xsl:template><!-- photo -->

	<xsl:template match="calendar">
    <form id="calendar">
      <p id="calhead">Calendar</p>
      <div id="calbody">
        <input type="button" class="arrow" onclick="cal.decYear()" value="&lt;"/>
        <input id="year" type="text" maxlength="4" onchange="cal.setYear()"/>
        <input type="button" class="arrow" onclick="cal.incYear()" value="&gt;"/>
        <input type="button" class="arrow" onclick="cal.decMonth()" value="&lt;"/>
        <select id="month" onchange="cal.setMonth()">
<option>Jan</option>
<option>Feb</option>
<option>Mar</option>
<option>Apr</option>
<option>May</option>
<option>Jun</option>
<option>Jul</option>
<option>Aug</option>
<option>Sep</option>
<option>Oct</option>
<option>Nov</option>
<option>Dec</option>
        </select>
        <input type="button" class="arrow" onclick="cal.incMonth()" value="&gt;"/>
        <input type="button" class="button" onclick="cal.setNow()" value="Now"/>
        <table id="days">
<tr><th>Sun</th><th>Mon</th><th>Tue</th><th>Wed</th><th>Thu</th><th>Fri</th><th>Sat</th></tr>
<tr><td id="0"></td><td id="1"></td><td id="2"></td><td id="3"></td><td id="4"></td><td id="5"></td><td id="6"></td></tr>
<tr><td id="7"></td><td id="8"></td><td id="9"></td><td id="10"></td><td id="11"></td><td id="12"></td><td id="13"></td></tr>
<tr><td id="14"></td><td id="15"></td><td id="16"></td><td id="17"></td><td id="18"></td><td id="19"></td><td id="20"></td></tr>
<tr><td id="21"></td><td id="22"></td><td id="23"></td><td id="24"></td><td id="25"></td><td id="26"></td><td id="27"></td></tr>
<tr><td id="28"></td><td id="29"></td><td id="30"></td><td id="31"></td><td id="32"></td><td id="33"></td><td id="34"></td></tr>
<tr><td id="35"></td><td id="36"></td><td id="37"></td><td id="38"></td><td id="39"></td><td id="40"></td><td id="41"></td></tr>
        </table>
        <div id="time">
          <input type="button" class="arrow" onclick="cal.decHour()" value="&lt;"/>
          <input id="hour" type="text" maxlength="4" onchange="cal.setHour()"/>h
          <input type="button" class="arrow" onclick="cal.incHour()" value="&gt;"/>
          <input type="button" class="arrow" onclick="cal.decMinute()" value="&lt;"/>
          <input id="minute" type="text" maxlength="4" onchange="cal.setMinute()"/>m
          <input type="button" class="arrow" onclick="cal.incMinute()" value="&gt;"/>
          <input type="button" class="arrow" onclick="cal.decSecond()" value="&lt;"/>
          <input id="second" type="text" maxlength="4" onchange="cal.setSecond()"/>s
          <input type="button" class="arrow" onclick="cal.incSecond()" value="&gt;"/>
        </div>
        <div id="julian">
          <input type="button" class="arrow" onclick="cal.decJD()" value="&lt;"/>
          JD<input id="jdinput" type="text" onchange="cal.setJD()"/>(Enter)
          <input type="button" class="arrow" onclick="cal.incJD()" value="&gt;"/>
        </div>
      </div>
    </form>
	</xsl:template><!-- calendar -->

	<xsl:template match="*|@*|text()"> <!-- Catch anything else in the page except head stuff and just copy it out -->
		<xsl:if test="name(.)!='css' and name(.)!='js' and name(.)!='title' and name(.)!='meta'">
			<xsl:copy>
				<xsl:copy-of select="@*"/><xsl:apply-templates/>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<xsl:template name="copyright">
		<div id="copyright">Copyright &copy; Graham Relf, UK, 2006-2017</div>
	</xsl:template>
	
	<xsl:template name="fromAtoZ">
		<div class="from">
			<a href="#A">A</a>
			<a href="#B">B</a>
			<a href="#C">C</a>
			<a href="#D">D</a>
			<a href="#E">E</a>
			<a href="#F">F</a>
			<a href="#G">G</a>
			<a href="#H">H</a>
			<a href="#I">I</a>
			<a href="#J">J</a>
			<a href="#K">K</a>
			<a href="#L">L</a>
			<a href="#M">M</a>
			<a href="#N">N</a>
			<a href="#O">O</a>
			<a href="#P">P</a>
			<a href="#Q">Q</a>
			<a href="#R">R</a>
			<a href="#S">S</a>
			<a href="#T">T</a>
			<a href="#U">U</a>
			<a href="#V">V</a>
			<a href="#W">W</a>
			<a href="#X">X</a>
			<a href="#Y">Y</a>
			<a href="#Z">Z</a>
		</div>
	</xsl:template>

</xsl:stylesheet>
